/*~!DO NOT EDIT!~
* This file was automatically generated by GSharpDSL.
* No changes will be saved on next compilation.
* @Zestas Orestis.
*/

using GraphLibrary;
using System;
using System.Collections.Generic;
using GraphLibrary.Algorithms;

namespace GSharpDSL {

    public class AlgTwoQueryInfo : CGraphQueryInfo<Int32?,String,Dictionary<CGraphNode,Dictionary<CGraphNode,Path>>> {    
        //CONSTRUCTOR    
        public AlgTwoQueryInfo(CGraph graph, object key) : base(graph,key) { }    

        //NODE ACCESSOR        
        public Int32? GetNodeInfo(CGraphNode node) {        
            return Info(node);        
        }        
        //NODE MODIFIER        
        public void SetNodeInfo(CGraphNode node, Int32? info) {        
            CreateInfo(node, info);        
        }        
        //EDGE ACCESSOR        
        public String GetEdgeInfo(CGraphEdge edge) {        
            return Info(edge);        
        }        
        //EDGE MODIFIER        
        public void SetEdgeInfo(CGraphEdge edge, String info) {        
            CreateInfo(edge, info);        
        }        
        //GRAPH ACCESSOR        
        public Dictionary<CGraphNode,Dictionary<CGraphNode,Path>> GetGraphInfo() {        
            return Info();        
        }        
        //GRAPH MODIFIER        
        public void SetGraphInfo(Dictionary<CGraphNode,Dictionary<CGraphNode,Path>> info) {        
            CreateInfo(info);        
        }        

    }
    //CGraphAlgorithm    
    public partial class AlgTwo : CGraphAlgorithm<int> {    
        private AlgTwoQueryInfo m_outputAlgTwoQueryInfo;    
        private Int32 myinput;        
        private string MYOUTPUT_KEY = "myoutputBank";        

        //CGraphAlgorithm CONSTRUCTOR        
        public AlgTwo(CGraph graph, object graphKEY) {        
            m_outputAlgTwoQueryInfo = new AlgTwoQueryInfo(graph, graphKEY);        
        }        
        //CGraphAlgorithm NODE ACCESSOR        
        protected Int32? GetNodeInfo(CGraphNode node) {        
            return m_outputAlgTwoQueryInfo.GetNodeInfo(node);        
        }        
        //CGraphAlgorithm NODE MODIFIER        
        protected void SetNodeInfo(CGraphNode node, Int32? info) {        
            m_outputAlgTwoQueryInfo.SetNodeInfo(node, info);        
        }        
        //CGraphAlgorithm EDGE ACCESSOR        
        protected String GetEdgeInfo(CGraphEdge edge) {        
            return m_outputAlgTwoQueryInfo.GetEdgeInfo(edge);        
        }        
        //CGraphAlgorithm EDGE MODIFIER        
        protected void SetEdgeInfo(CGraphEdge edge, String info) {        
            m_outputAlgTwoQueryInfo.SetEdgeInfo(edge, info);        
        }        
        //CGraphAlgorithm GRAPH ACCESSOR        
        protected Dictionary<CGraphNode,Dictionary<CGraphNode,Path>> GetGraphInfo() {        
            return m_outputAlgTwoQueryInfo.GetGraphInfo();        
        }        
        //CGraphAlgorithm GRAPH MODIFIER        
        protected void SetGraphInfo( Dictionary<CGraphNode,Dictionary<CGraphNode,Path>> info) {        
            m_outputAlgTwoQueryInfo.SetGraphInfo(info);        
        }        
        
        private void StoreOutput(string key, object value) {        
            IOBank.SetValueForItemInBank(key,value);        
        }        
        private void InitializeInputs() {        
            myinput = (Int32)IOBank.GetItemFromBank("myintBank");            
        
        }
    }

}
